// BeerExpert.java  for CISC474, H07, P. Conrad, Spring 2007

package edu.udel.cisc474.pconrad.BeerAdvisor.model;
import java.util.*;

/**
 * <p>
 * BeerExpert provides recommendations for Beers based on
 * user input.   It provides an abstraction of the actual data
 * source, which can be hard coded values, or an SQL database.
 * <p>
 * BeerExpert represents the "Model" part of a beer advisory 
 * system based on the
 * Model-View-Controller design pattern.
 * <p>
 * The original is based on code from p. 82 of 
 * "Head First Servlets and JSP", 1st Edition.
 * 
 * @author    P.Conrad, based on code from HFSJ
 */


public class BeerExpert {


/**
 * Given a color of beer, returns a list of beers that
 * match that color. 
 * 
 * @param color       the color of beer the user prefers (e.g. <code>"amber"</code>)
 * @return            a List<String> object containing the names of the
 *                    beers that match that color.
 * @see BeerExpertTest
 */

    public List<String> getBrands(String color) {

	List<String> brands = new ArrayList<String>();

	// ** change next line to true to make JUnit tests fail
	final boolean stubForCheckingJUnitTests = false;

	if (stubForCheckingJUnitTests)
	    return brands; // returns an empty list
	 
	if (color.equals("amber")) {
	    brands.add("Jack Amber");
	    brands.add("Red Moose");
	}
	else {
	    brands.add("Jail Pale Ale");
	    brands.add("Gout Stout");
	}
	return (brands);

    }

    /**
       main is a command line "view/controller" that 
       takes a color as first command line arg, calls
       getBrands, and lists all returned brands
    */

    public static void main(String args[]) {

	if (args.length != 1)
	    {
		System.err.println("Usage: java BeerExpert color");
		System.exit(1);
	    }

	String color = args[0];

	BeerExpert be = new BeerExpert();
	
	List<String> brands = be.getBrands(color);

	System.out.println("Try:");
	for (String brand: brands)
	    {
		System.out.println(" " + brand);
	    }

	System.exit(0);
    }


}
