// BeerExpertTest.java  for CISC474, H07, P. Conrad, Spring 2007

package edu.udel.cisc474.pconrad.BeerAdvisor.model;

import java.util.*;
import junit.framework.*;

/**
 * 
 * BeerExpertTest performs unit testing on BeerExpert
 * 
 * @author    P.Conrad
 * @see       BeerExpert
 */

public class BeerExpertTest extends TestCase 
{
    private BeerExpert be;


/**
 * main to run the JUnit tests at command line
 */

    public static void main(String args[]) 
    {
	junit.textui.TestRunner.run(BeerExpertTest.class);
    }

/**
 * Creates a BeerExpert object <code>be</code> that serves
 * as the basis for all the other tests.
 */

    
    protected void setUp()
    {
	be = new BeerExpert();
    }
    
    // Note that this is a set of JUnit tests for the
    // exact code that is on page 82 of 
    // "Head First Servlets and JSP", 1st Edition.
    //
    // That code is kind of a dumb model for beer advice
    // since everything _except_ amber returns exactly
    // the same list.  But, that being said, the following
    // JUnit tests should test whether it works properly.

    // For a real beer advisor, driven from a database, 
    // you'd probably choose a small number of test cases
    // that are "representative"---not try to cover every possibility.

/**
 * Tests getBrands method when passed <code>"amber"</code>
 */


    public void testGetBrands1()
    {
	List<String> brands = be.getBrands("amber");
	// make sure the list has two elements
	assertEquals(brands.size(),2);

	// make sure Jack Amber is one of them
	assertTrue(brands.indexOf("Jack Amber")!=-1);

	// make sure Red Moose is the other
	assertTrue(brands.indexOf("Red Moose")!=-1);

    }

/**
 * Tests getBrands method when passed something other than <code>"amber"</code>
 */


    public void testGetBrands2()
    {
	List<String> brands = be.getBrands("dark");
	// make sure the list has two elements
	assertEquals(brands.size(),2);

	// make sure Jail Pale Ale is one of them
	assertTrue(brands.indexOf("Jail Pale Ale")!=-1);

	// make sure Gout Stout is the other
	assertTrue(brands.indexOf("Gout Stout")!=-1);

    }

    
}
